"conv.gp.1d" <-
function(data, pdata=NULL, w, sdkern=2, method="bayes", iter=2000, ay=1, by=0.005, ax=1, bx=0.005)
{
	# input data
	s <- data$s; y <- data$y;
	m <- length(w);
	
	# create the matrix K for the input data and predictive locations
	K <- new.K.1d(s, w, sdkern)
	K.pred <- new.K.1d(pdata, w, sdkern)

	# estimation
	if(method == "lme") ll <- conv.lme(y, m, K, K.pred)
	else ll <- conv.bayes(y, m, K, K.pred, iter=iter, ay=ay, by=by, ax=ax, bx=bx)
	ll$s = s; ll$w = w; ll$sdkern=sdkern; ll$s.pred=pdata

        class(ll) <- "conv"
	return(ll)
}

