"conv.gp.2d" <-
function(data, pdata=NULL, w, sdkern, method="bayes", iter=2000, ay=1, by=0.005, ax=1, bx=0.005)
{
	# input data
	s <- data$s; y <- data$y;
	n <- length(y); m <- dim(w)[1]

	# create the matrix K
	K <- new.K.2d(s, w, sdkern)
	K.pred <- new.K.2d(pdata, w, sdkern)
	
	# estimation
	if(method == "lme") ll <- conv.lme(y, m, K, K.pred)
	else ll <- conv.bayes(y, m, K, K.pred, iter=iter, ay=ay, by=by, ax=ax, bx=bx)
	ll$s = s; ll$w = w; ll$sdkern=sdkern; ll$s.pred=pdata

        class(ll) <- "conv"
	return(ll);
}

