"conv.gp.multi.1d" <-
function(data, pdata=NULL, w, sdkern, method="bayes", iter=2000, ay=1, by=0.005, ax=1, bx=0.005)
{
	s <- data$s; y <- data$y;

	# generate K matricies for each scale
	K <- new.K.multi.1d(s, w, sdkern)
	K.pred <- new.K.multi.1d(pdata, w, sdkern)

	# estimation
	if(method == "lme") ll <- conv.lme.multi(y, w, K, K.pred)
	else ll <- conv.bayes.multi(y, w, K, K.pred, iter=iter, ay=ay, by=by, ax=ax, bx=bx)
	ll$s = s; ll$w = w; ll$sdkern=sdkern; ll$s.pred=pdata

        class(ll) <- "conv"
	return(ll)
}

