"conv.lme" <-
function(y, m, K, K.pred)
{
	# create a dataframe to hold the data
	df1 <- data.frame(y=y,K=K,sub=1)
	df1$sub <- as.factor(df1$sub)

	# ``random'' formula
	r = "~ K.1"
	for(i in 2:m) { r <- paste(r, "+K.", i, sep="") }
	r <- formula(paste(r, "-1", sep=""))

	# fit mixed effects model
	library(nlme)
	a1 <- lme(fixed= y~1, random=list(sub=pdIdent(r)), 
		data=df1, na.action=na.omit)
	a1$z <- as.vector(predict(a1,df1))
	if(!is.null(K.pred))
		a1$z.pred <- as.vector(cbind(rep(1,dim(K.pred)[1]), K.pred) %*% as.numeric(coefficients(a1)))

	return(list(method="lme", a=a1, df=df1));
}

