"conv.lme.multi" <-
function(y, w, K, K.pred, method="bayes")
{
	m <- length(w)
	
	r <- list()
	df2 <- data.frame(y=y, sub=1);
	df2$sub <- as.factor(df2$sub)

	# construct formula
	for(j in 1:m) {
		str <- paste("K", j, sep="")
		mw <- dim(w[[j]])[1];
		if(is.null(mw)) { mw <- length(w[[j]]) }
		for(i in 1:mw) { 
			str2 <- paste(str, "." , i, sep="")
			df2[[str2]] <- K[[j]][,i]
		}
		r[[j]] = paste("~ ", str, ".1", sep="")
		for(i in 2:mw) { r[[j]] <- paste(r[[j]], "+", str, ".", i, sep="") }
		r[[j]] <- pdIdent(formula(paste(r[[j]], "-1", sep="")))
	}
	names(r) <- rep("sub", length(r))

	# fit mixed effects model
	library(nlme)
	a2 <- lme(fixed= y~1, random=r, data=df2, na.action=na.omit)
	a2$z <- as.vector(predict(a2,df2))

	if(!is.null(K.pred)) {
		a2$z.pred <- as.numeric(a2$coef$fixed)
		for(j in 1:m) a2$z.pred = a2$z.pred + as.vector(K.pred[[j]] %*% as.numeric(a2$coef$random[[j]]))
	}

	return(list(method="lme", a=a2, df=df2));
}

