"conv.plot.1d" <-
function(ll, main="1-d Artificial Data", burn=500)
{
	# extract from list ll
	df <- ll$df;
	a <- ll$a;

	if(ll$method == "lme") {
		a1p <- a$z
		if(!is.null(ll$s.pred)) a1p <- c(a1p, a$z.pred)
		o <- order(c(ll$s, ll$s.pred))
		a1p <- a1p[o]
		x <- c(ll$s, ll$s.pred)[o]
		upper <- a1p + 1.96*a$sigma
		lower <- a1p - 1.96*a$sigma
		main <- paste(main, "(lme)")
	} else {  # "bayes"
		a1p.all <- a$z[burn:(dim(a$z))[1],]
		if(!is.null(ll$s.pred)) a1p.all <- cbind(a1p.all, a$z.pred[burn:(dim(a$z.pred))[1],])
		o <- order(c(ll$s, ll$s.pred))
		a1p.all <- a1p.all[,o]
		x <- c(ll$s, ll$s.pred)[o]
		a1p <- apply(a1p.all,2,mean)
		zbounds <- apply(a1p.all,2,quantile,c(.025,.975))
		lower <- zbounds[1,]
		upper <- zbounds[2,]
		if(ll$method == "met.coup") main <- paste(main, "(Metropolis-coupled Bayes)")
		else main <- paste(main, "(Bayes)")
	}
	if(!is.null(ll$s.pred)) main <- paste(main, "[with pred]")
	
	plot(ll$s,df$y, main=main)

	# plot kernels
	if(is.list(ll$w)) { for(i in 1:length(ll$w)) { abline(v=(ll$w)[[i]], lty=i+1, col=i+1) } }
	else { abline(v=ll$w, lty=2, col="green") }

	# obtain and plot the fitted values
	lines(x,a1p,lty=1, lwd=2)
	lines(x,upper,lty=2, lwd=2)
	lines(x,lower,lty=2, lwd=2)

	if(ll$method == "met.coup") { # plot the course level
		a1p.all <- a$zc[burn:(dim(a$zc))[1],]
		if(!is.null(ll$s.pred)) a1p.all <- cbind(a1p.all, a$zc.pred[burn:(dim(a$zc.pred))[1],])
		o <- order(c(ll$sc, ll$sc.pred))
		a1p.all <- a1p.all[,o]
		x <- c(ll$sc, ll$sc.pred)[o]
		a1p <- apply(a1p.all,2,mean)
		zbounds <- apply(a1p.all,2,quantile,c(.025,.975))
		lower <- zbounds[1,]
		upper <- zbounds[2,]

		# and plot
		points(ll$sc, df$yc, pch=20, col="red")
		lines(x,a1p,lty=4, lwd=2, col="red")
		lines(x,upper,lty=3, lwd=2, col="red")
		lines(x,lower,lty=3, lwd=2, col="red")
	}
	
}

