"conv.plot.2d" <-
function(ll, main="2-d Ozone Data", burn=500)
{
	# extract from list ll
	df <- ll$df;
	a <- ll$a;
	x <- ll$s[,1]; y <- ll$s[,2]; z <- df$y;
	x.pred <- ll$s.pred[,1]; y.pred <- ll$s.pred[,2];

	if(ll$method == "lme") {
		ap <- a$z
		if(!is.null(ll$s.pred)) ap <- c(ap, a$z.pred)
		main <- paste(main, "(lme)")
	} else { # "bayes"
		ap.all <- a$z[burn:(dim(a$z))[1],]
		if(!is.null(ll$s.pred)) ap.all <- cbind(ap.all, a$z.pred[burn:(dim(a$z))[1],])
		ap <- apply(ap.all,2,mean)
		main <- paste(main, "(Bayes)")
	}
	if(!is.null(ll$s.pred)) main <- paste(main, "[with pred]")

	# plot original and smoothed
	par(mfrow=c(1,2), bty="n")

	# Original
	grid.orig <- interp(x,y,z)
	image(grid.orig, col=terrain.colors(128), main="Original")
	points(x,y,col=gray(z/max(z)), pch=20)

	# Original, smoothed
	grid.orig <- interp(c(x,x.pred),c(y,y.pred),ap)
	image(grid.orig, col=terrain.colors(128), main=paste(main, "Smoothed via GP"))
	points(x,y,col=gray(z/max(z)), pch=20)

	# kernels
	if(! is.matrix(ll$w)) {
		for(i in 1:length(ll$w)) {
			ww <- ll$w[[i]]
			points(x=ww[,1], y=ww[,2], cex=2*sum(diag(ll$sdkern[[i]])), col=i+1);
		}
	} else { points(ll$w[,1], ll$w[,2], cex=2*sum(diag(ll$sdkern))); }
}

