"hrm" <-
function(data, m=12, Gbig=5000, nys=5, harms=c(6,3,2))
{
	nh <- length(harms)
	data <- as.vector(data)

	ll <- .C("hrm", 
		data = as.double(data), 		# (in) xlevel
		nx = as.integer(length(data)),		# (in) nx
		m = as.integer(m),			# (in) m
		Gbig = as.integer(Gbig),		# (in) Gbig
		nys = as.integer(nys),			# (in) nys
		nh = as.integer(nh),			# (in) length(harms)
		harms = as.integer(harms),		# (in) harmonics
		lambda = double(Gbig),			# lambda (out)
		ysample = double(nys*Gbig),		# ysample (out)
		theta = double((5+2*nh)*Gbig),		# theta (out)
                PACKAGE = "mrm"
        )

	theta.m <- t(matrix(ll$theta, nrow=5+2*nh))
	ysample.m <- t(matrix(ll$ysample, nrow=nys))
	ll$theta <- data.frame(
		phiy=theta.m[,1], sigmay2=theta.m[,2], phix=theta.m[,3], 
		sigmax2=theta.m[,4], tau=theta.m[,5], beta=theta.m[,6:(5+2*nh)]
	)
	ll$ysample <- ysample.m

        class(ll) <- "hrm"
	return(ll)
}

