"hrm.fcast" <-
function(hrm.out, window=3, burnin=1000)
{
	if(burnin >= hrm.out$Gbig) {
		print(paste("ERROR: burnin", burnin, "too large"))
	}

	ho <- hrm.out
	consid <- ho$Gbig - burnin
	rounds <- burnin : ho$Gbig

	ll <- .C("hrm_fcast", 
		window = as.integer(window),				# (in) window
		data = as.double(ho$data), 				# (in) xlevel
		nx = as.integer(ho$nx),					# (in) nx
		m = as.integer(ho$m),					# (in) m
		consid = as.integer(consid),				# (in) consid
		nys = as.integer(ho$nys),				# (in) nys
		nh = as.integer(ho$nh),					# (in) length(harms)
		harms = as.integer(ho$harms),				# (in) harmonics
		ysample = as.double(t(ho$ysample[rounds,])),		# (in) ysample
		theta = as.double(t(as.matrix(ho$theta[rounds,]))),	# (in) theta
		fcast = double(ho$m*window*(consid)),		       	# fcast (out)
                PACKAGE = "mrm"
        )

	fcast.m <- t(matrix(ll$fcast, nrow=(ho$m*3)))
	hrm.out$fcast = fcast.m;
	hrm.out$window = window
	return(hrm.out)
}

