"plot.hrm" <-
function(x, burnin=1000, ...)
{
	if(burnin >= x$Gbig) {
		print(paste("ERROR: burnin", burnin, "too large"))
	}

	phiy<-x$theta$phiy 
	sigmay2 <-x$theta$sigmay2
	phix <- x$theta$phix
	sigmax2 <-x$theta$sigmax2
	tau <-x$theta$tau
	theta <- x$theta
	lambda<-x$lambda
	gsize<-length(phix)

	# Trace of the parameters:
	par(mfrow=c(3,2))
	plot.ts(phiy, main="phiy")
	plot.ts(sigmay2, main="sigma2")
	plot.ts(phix, main="phix")
	plot.ts(sigmax2, main="sigma2")
	plot.ts(tau, main="tau2")
	plot.ts(lambda, main="lambda")
	readline(prompt="press RETURN for next plot ")

	#Trace of the regressor coeficients:
	par(mfrow=c(x$nh,2), bty="n")
	for(i in 6:(5+2*x$nh)) {
		plot.ts(theta[,i])
		title(paste("beta", i-5))
	}
	readline(prompt="press RETURN for next plot ")

	par(mfrow=c(3,2))
	hist(phiy[burnin:gsize],xlab="phiy")
	hist(sigmay2[burnin:gsize],xlab="sigmay2")
	hist(phix[burnin:gsize],xlab="phix")
	hist(sigmax2[burnin:gsize],xlab="sigmax2")
	hist(tau[burnin:gsize],xlab="tau")
	hist(lambda[burnin:gsize],xlab="lambda")
	readline(prompt="press RETURN for next plot ")

	par(mfrow=c(x$nh,2), bty="n")
	for(i in 6:(5+2*x$nh)) {
		hist(theta[burnin:gsize,i], xlab=paste("beta", i-5), 
			main= title(paste("Histogram of beta", i-5)))
	}
}

