"plot.hrm.fcast" <-
function(x, start=1990, truth=NULL, ...)
{
	window <- x$window
	m <- x$m
	le <- x$fcast

	LL <- 1:(window*m)
	UU <- 1:(window*m)
	media <- 1:(window*m)

	for(i in 1:(window*m)){
  		LL[i] <- quantile(le[,i],0.025)
  		UU[i] <- quantile(le[,i],0.975)
  		media[i] <- mean(le[,i])
	}

	le2<- x$data
	le2 <- log(le2)
	aux <- mean(le2)
	fine <- le2
	nx <- length(fine)

	LLms <- LL+aux
	UUms <- UU+aux
	mediams <- media+aux

	if(! is.null(truth)) { truth <- log(truth) }

	if(! is.null(truth)) { obs <- ts(truth,start=start,frequency=m) }
	else { obs <- NULL; }
	LLms <- ts(LLms,start=start,frequency=m)
	UUms <- ts(UUms,start=start,frequency=m)
	mediams <- ts(mediams,start=start,frequency=m)

	#library(ts)
	ts.union(obs,LLms,UUms,mediams)

	par(mfrow=c(1,1), bty="n");

	ts.plot(mediams,LLms,UUms,obs,gpars=list(lty=c(2,3,3,1),lwd=c(1.5,2.5,2.5,1.5)))
	readline(prompt="press RETURN for next plot ")

	obs <- ts(c(fine[(nx-window*m+1):nx], truth),start=start-window,frequency=m)
	ts.plot(mediams,LLms,UUms,obs,lty=c(2,3,3,1),lwd=c(1.5,2.5,2.5,1.5))
	abline(v=start-0.5/m, col="red", lty=2, lwd=2)
}

