\name{data.1d}
\alias{data.1d}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Generate Synthetic Sinusoidal Data }
\description{
  A function that random (1-d) data whose mean is a process which is a mixture
  of a major sinusoidal process, and a minor cosine process -- perfect
  for illustrating multi-resolution models.
}
\usage{
data.1d(n = 30, xlim = c(1, 10), sd = 0.1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{n}{ Number of samples requested }
  \item{xlim}{ 2-vector of minimum and maximum spatial inputs; default
    is \code{c(1,10)}}
  \item{sd}{ Standard deviation of zero-mean Normal deviates (noise) to
    add to the response }
}
\details{
  \code{E[y(x)] = sin(x/10*2*pi) + sin(x/10*2*pi)}, 

  observed with N(1,\code{sd}) noise
}
\value{
  Output is a list containing fields which are vectors of equal length
  (\code{n}) :

  \item{s }{Spatial locations evenly spaced within \code{xlim} }
  \item{y }{Responses according to the formula above, taking \code{x=s} }
  
}

\references{
Higdon, D. (2002).
\emph{Space and space-time modeling using process convolutions}.
Quantitative Methods for Current Environmental Issues (pp.
37--56). London: Springer-Verlag. }

\author{ Robert B. Gramacy \email{rbgramacy@ams.ucsc.edu} }
%\note{ ~~further notes~~ 
%~Make other sections like Warning with \section{Warning }{....} ~
%}
\seealso{ \code{\link{hrm}} }
\examples{
data <- data.1d()
}
\keyword{ datagen }% at least one, from doc/KEYWORDS
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
