\name{hrm.fcast}
\alias{hrm.fcast}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Forecasting for the Hidden Resolution Multi-scale Time Series
  Model }
\description{
  Code for forecasting for Bayesian Hidden Resolution Time Series Model
  using Markov chain Monte Carlo (MCMC)
}
\usage{
hrm.fcast(hrm.out, window = 3, burnin = 1000)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ hrm.out }{ Output from the \code{\link{hrm}} function}
  \item{ window }{ Number of course-level times to forecast ahead of
    \code{hrm.out$data}, i.e., if \code{m=12}, number of years to
    forecast ahead }
  \item{ burnin }{ Integer, number of rounds of \code{hrm.out$Gbig} to be
    treated as burn in.  Requires \code{ 0 <= burnin < hrm.out$Gbig } }
}
\details{
  Number of MCMC rounds is \code{hrm.out$Gbig - burnin}.
}

\value{
  This function is designed \emph{add/append} to the input argument
  \code{hrm.out} so it would be proper for the return value and first
  argument to be the same.  See examples attached to \code{\link{hrm}}

  Therefore, the output is a list with the entries copied from
  \code{hrm.out}, with the following entries added

  \item{ window }{Copy of input parameter, \code{window}}
  \item{ fcast }{ \code{matrix}, where \code{dim(fcast) = c(harm.out$Gbig
  - burnin, m*window)} containing \code{harm.out$Gbig - burnin} samples
  for the posterior distribution of the fine process for each
  \code{m*window} time steps ahead }
}

\references{ Marco A. R. Ferreira, Mike West, Herbert K. H. Lee and
	David Higdon (2006), \emph{Multi-scale and hidden resolution time
	series models.} Bayesian Analysis, to appear.  }

\author{ Robert B. Gramacy \email{rbgramacy@ams.ucsc.edu} and Marco Ferreira
\email{marco@im.ufrj.br}}

\seealso{ \code{\link{hrm}}, \code{\link{plot.hrm.fcast}} }
\keyword{ ts }% at least one, from doc/KEYWORDS
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
