\name{plot.hrm}
\alias{plot.hrm}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Plotting of MCMC samples for Hidden Resolution Multi-Scale Time
  Series Models }
\description{
  A function for visualizing the convergence of Markov chains used for
  inference in Bayesian estimation of Hidden Resolution Multi-Scale Time
  Series Models
}
\usage{
plot.hrm(x, burnin = 1000, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ x }{ Output from the \code{\link{hrm}} function}
  \item{ burnin }{ Integer, number of rounds of \code{hrm.out$Gbig} to be
    treated as burn in.  Requires \code{ 0 <= burnin < hrm.out$Gbig } }
  \item{ ... }{ Passed to \code{\link{plot}} }
}
\details{
  This function makes a sequence of plots.  The first plot in the
  sequence shows the Markov chains for phiy-sigma2, phix-sigma2,
  tau2-lambda.  The next plot(s) in the sequence show the chains for the
  harmonic Beta parameters. The third plot(s) in the sequence shows
  histograms for phiy-sigma2, phix-sigma2, tau2-lambda, and likewise in
  the final plot for the Betas.
}
\value{
  No returned output... only a series of plots sent to a
  graphics window
}

\references{ Marco A. R. Ferreira, Mike West, Herbert K. H. Lee and
	David Higdon (2006), \emph{Multi-scale and hidden resolution time
	series models.} Bayesian Analysis, to appear.  }

\author{ Robert B. Gramacy \email{rbgramacy@ams.ucsc.edu} and Marco Ferreira
\email{marco@im.ufrj.br}}

\seealso{ \code{\link{hrm}}, \code{\link{plot}} }

\keyword{ hplot }% at least one, from doc/KEYWORDS
\keyword{ ts }% __ONLY ONE__ keyword per line
