\name{plot.hrm.fcast}
\alias{plot.hrm.fcast}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Plotting of Forecasts from a Hidden Resolution Multi-Scale Time
  Series Model }
\description{
  A function for plotting of the MCMC forecasts obtained via the
  \code{hrm.fcast} function for a Bayesian estimated Hidden Resolution
  Multi-Scale Time Series Model
}
\usage{
plot.hrm.fcast(x, start = 1990, truth = NULL, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ x }{ Output from the \code{\link{hrm}} function}
  \item{ start }{ Time Series x-label for the first forecast element in
    to be plotted }
  \item{ truth }{ Vector of true fine-level time series observations for
    comparison.  Requires \code{length(truth) == dim(hrm.out$fcast)[2]},
    or \code{NULL} for no comparison (default) }
  \item{ ... }{ Passed to \code{\link{plot}} }
}
\details{
  This function makes a sequence of plots.  The first plot in the
  sequence shows the mean and posterior credible interval from the
  predictive distribution of forecasts.  The second plot in the series
  shows the forecasts (from the last plot) appended to the original time
  series \code{hrm.out$data}
}
\value{
  No returned output... only a series of plots sent to a
  graphics window
}

\references{ Marco A. R. Ferreira, Mike West, Herbert K. H. Lee and
	David Higdon (2006), \emph{Multi-scale and hidden resolution time
	series models.} Bayesian Analysis, to appear.  }

\author{ Robert B. Gramacy \email{rbgramacy@ams.ucsc.edu} and Marco Ferreira
\email{marco@im.ufrj.br}}

\seealso{ \code{\link{hrm}}, \code{\link{hrm.fcast}}, \code{\link{plot}}}
\keyword{ hplot }% at least one, from doc/KEYWORDS
\keyword{ ts }% __ONLY ONE__ keyword per line
