#include <stdlib.h>	
#include <math.h>
#include <stdio.h>

void compAV(double phix, double sigmax2, int m, int nx , int ny , double *AV)
{
  /* 
    Matrices are in FORTRAN format!!!
    Computes A * Vt in the particular case 
       A = (1/m) Kroneckerproduct(I_{n_y}, 1_m)
    and
       Vx = Covariance matrix of a AR(1) process
       */

double aux;
int i, j;

 /* Computing the first column  ... */
 AV[0] = (sigmax2*(1-pow(phix,(double)(m))))/((1-phix)*(1-phix*phix)*m);
 for(i=1;i<ny;i++)  AV[i] = AV[0] * pow(phix,(double)(i*m));

 /* Computing the other columns ... */
 aux = sigmax2/((1-phix*phix)*m);
 for(j=1;j<nx;j++)  
  for(i=0;i<ny;i++)  
   AV[j*ny+i] = AV[(j-1)*ny+i] + aux
     * (pow(phix,(double)(abs(i*m-j)))-pow(phix,(double)(abs((i+1)*m-j))));

} /* End of compAV */

/*
int main(void)
{
double *AV, phix, sigmax2;
int m, nx, ny, i, j;

 AV = (double *) malloc(ny * nx * sizeof(double));
 phix = 0.9;
 sigmax2 = 1.0;
 m  =  12;
 nx = 600;
 ny =  50;

 compAV(phix, sigmax2, m, nx, ny, AV);
 for(i=0;i<6;i++){
  for(j=0;j<6;j++)  printf("%10.4f ",AV[j*ny+i]);
  printf("\n");
 }

 free(AV);
}
*/



