#include <stdlib.h>	
#include <math.h>
#include <stdio.h>
#include "tipos.h"
#include "matrix.h"


void compW( PARAM *t, int m, int nx, int ny, double *W)
{
  /* Computing W = AVAt + tau * I 

     Note that the computation of AVAt is set for the
     particular case when A = (1/m) Kroneckerproduct(I_{n_y}, 1_m) 
     and Vx = Covariance matrix of a AR(1) process.     */

  int i/*, j, info*/;
  double alpha, /*beta,*/ aux;
  double *AVAt;

  AVAt = (double *)malloc((unsigned) (ny*ny)*sizeof(double));

  compAVAt((*t).phix,(*t).sigmax2,m,ny,AVAt);

  /* Computing W = AVAT + tau * I      */
  alpha = 1;
  dgemt("N",&ny,&ny,&alpha,AVAt,&ny,W,&ny);  /* W = AVAt */
  aux=(*t).tau;
  for(i=0;i<ny;i++) W[i*ny+i]=AVAt[i*ny+i]+aux;

  free(AVAt);
 
  return;
} /*  End of compW */
