#include <assert.h>	
#include <stdlib.h>	
#include <math.h>
#include "rand.h"
#include "setup.h"

/* #define PI 3.141592653589793 */
#define EE 2.718281828459046
/* seed(int s) - sets seed
   setseed(int s)
   runi() - uniform[0,1]
   runir(a,b) - uniform[a,b]
   runii(na,nb) - uniform on integers na to nb
   rnor(mu,sd) 
   rpois(mu) 
   rexponent(lambda) - exponential(lamda) mean = 1/lambda
   rcauchy(location,scale)
   rgamma(alpha)
   rbeta(alpha,beta) 
   rstudent(t) 
   rlogistic(location,scale)
   rlnorm(norm,norsd)
   rbin(n,p)
   rweibull(lambda)
   rf(t,u)
   rchisq(t) */
   
double rxxx1;
int ixxx1=0;
/*************************************/
void setseed(s)
int s;
   {
#ifndef RRAND
   void srand48();
   srand48((long)s);
#else
   GetRNGstate();
#endif
   }
/*************************************/
double runi()
 /*  old version ...
   {
   return ((double)rand() + 0.5)/((double)RAND_MAX + 1.0);
   }
 */
   {
#ifndef RRAND
   double drand48();
   /*static int idnum = -1;*/
   return drand48();
#else
   return unif_rand();
#endif
   }

void putseed()
{
#ifdef RRAND
     PutRNGstate();
#endif
}
/*************************************/
double runir(a,b)
double a,b;
{return (b-a)*runi()+a;}
/*************************************/
int runii(na,nb)
int na,nb;
{return floor((double)(runi()*(nb-na+1.)))+na;}
/*************************************/
double rnor(mu,sd)
double mu,sd;
{
   double e,v1,v2,w;
   if(ixxx1==0){
      do{
         v1=2*runi()-1.;
         v2=2*runi()-1.;
         w=v1*v1+v2*v2;      
      }while(w>1.);
      e=sqrt((-2.*log(w))/w);
      rxxx1=v1*e;
      ixxx1=1;
      return v2*e*sd+mu;
   }
   else{
      ixxx1=0;
      return rxxx1*sd+mu;
   }
}

/*************************************/
int rpois(mu)
double mu;
{ 
   double p=1.;
   int n=0;
   if(mu<=0)return 0;
   mu=exp(-mu);
   do{
      p=p*runi();
      n++;
   }while(p>=mu);
   return n-1;
}
/*************************************/
double rexponent(lambda)
double lambda;
{return -log(runi())/lambda;}
/*************************************/
double rcauchy(loc,scale)
double loc,scale;
{return tan((runi()-0.5)*PI)*scale+loc;}
/*************************************/
double rncauchy(loc,scale)
double loc,scale;
{
 double nscale;
 nscale = scale*.67;
 return tan((runi()-0.5)*PI)*nscale+loc;
}
/*************************************/
double rgamma(alpha)
double alpha;
{
   double r1,r2,aa,x,w,c1,c2,c3,c4,c5;
   if(alpha<=0.)return 0.;
   if(alpha == 1.)return rexponent(1.);
   if(alpha<1){
      aa=(alpha+EE)/EE;
      do{
         r1=runi();
         r2=runi();
         if(r1>1./aa){
            x = -log(aa*(1.-r1)/alpha);
            if(r2<pow(x,(alpha-1.)))return x;
         }
         else{
            x = pow((aa*r1),(1./alpha));
            if(r2<exp(-x))return x;
         }
      }while(r2<2);
   }
   else{
      c1=alpha-1;
      c2=(alpha-1./(6.*alpha))/c1;
      c3=2./c1;
      c4=c3+2.;
      c5=1./sqrt(alpha);
      do{
         do{
            r1=runi();
            r2=runi();
            if(alpha>2.5)r1=r2+c5*(1.-1.86*r1);
         }while(r1<=0 || r1 >= 1);
         w=c2*r2/r1;
         if(c3*r1+w+1/w <= c4)return c1*w;
         if(c3*log(r1)-log(w)+w<1)return c1*w;
      }while(r2<2);
   }
   assert(0);
   return -1;
}
/*************************************/
double rbeta(alpha,beta)
double alpha,beta;
{
   double r1;
   if(alpha <=0. || beta <= 0.) return 0.;
   r1=rgamma(alpha);
   return r1/(r1+rgamma(beta));
}
/*************************************/
double rlogistic(loc,scale)
double loc,scale;
{return (loc-(scale*log((1./runi())-1)));}
/*************************************/
double rlnorm(norm,norsd)
double norm,norsd;
{return exp(rnor(norm,norsd));}
/*************************************/
int rbin(n,p)
int n;
double p;
{
   int j=0,k;
   for(k=0;k<n;k++)if(runi()<p)j++;
   return j;
}
/*************************************/
double rweibull(gamma)
double gamma;
{
   if(gamma<=0)return 0.;
   return pow(rexponent(1.),(1/gamma));
}
/*************************************/
double rchisq(t)
double t;
{return rgamma(t/2.0)*2.;}
/*************************************/
double rf(t,u)
double t,u;
{
   if(t<=0 || u <= 0)return 0.;
   return rchisq(t)*u/(t*rchisq(u));
}
/*************************************/
double rstudent(t)
double t;
{
   /*double r1,r2;*/
   if(t<=0.)return 0.;
   return rnor(0.,1.)/sqrt(rchisq(t)/t);
}
/*************************************/

double invgamma_logpdf(double x, double alpha, double beta)
{
  /* Returns the value at x of the log of the pdf of the 
     Inverse Gamma distribution with parameters alpha and beta */

  /* Note that lgamma is from the standard library math.h. It  */

  double aux;

  aux = -lgamma(alpha) + alpha*log(beta) - (alpha+1)*log(x) - beta/x;
  
  return aux;
}

double normal_pdf(double x, double m, double s)
/* returns the value of the density of the normal(m,s^2) at x. */ 
{
  double aux, f;
  aux = (x-m)/s;
  f = exp(-aux*aux/2.0) / sqrt(2.0*PI*s*s);

  return f;
}

double truncnormal_pdf(double x, double m, double s, double l, double r)
/* returns the value at x of the density of the truncated
   normal(m,s^2), truncated in the interval [l,r]. */ 
{
  double f;
  if ((x<l)||(x>r)) return 0.0;
  f = normal_pdf(x,m,s) / (normal_cdf((r-m)/s)-normal_cdf((l-m)/s));

  return f;
}

/*************************************/
double rtruncnormal(double m, double s, double left, double right)
/* returns y ~ N(m,s^2), with left < y < right */
{
  double u, pleft, pright, y, aux;

  aux = (left-m)/s;
  pleft = normal_cdf(aux);
  aux = (right-m)/s;
  pright = normal_cdf(aux);
  u = pleft + (pright-pleft)*runi();
  y = m + s * normal_invcdf(u);
  return y;
}

void rmvnorm(double *mean, double *L, int p, double *result)
/**************************************************************
random realization from a p-variate N(mean,Sigma) distribution
with Sigma = LL'.  Choleski decomp of Sigma is required.
  mean[p] mean of the normal distribution.
  L  is p by p Choleski decomp of the covariance matrix in FORTRAN format.
  result[p] The p-variate realization.
**************************************************************/
{
  int i, j, k, auxi;
  double *z;
  z = (double *)malloc((unsigned) (p)*sizeof(double));
     
  for(k=0;k<p;k++) z[k] = rnor(0.0,1.0);

  for(i=0;i<p;i++) result[i] = mean[i];
  for(j=0;j<p;j++){
    auxi = j*p;
    for(i=j;i<p;i++) result[i] += L[i+auxi]*z[j];
  }

  free_dvector(z,0,p-1);
  return;
}

double normal_cdf(double X)
{
/* ##################################################################
! #                                                                #
! #  Computes the cumulative distribution function of a standard   #
! #  normal at the point X.                                        #
! #                                                                #
! ##################################################################*/


  
  double cdf, xm, xr, dx, yy;
  double x[5], w[5];
  
  int i;

  /* printf(" X = %lg \n",X); */

  if( X >= 10.0)
  return(1.0);
  
  else if (X <= -10.0)
    return(0.0);
  
  else
    {
      yy = X;
      if(yy < 0.0)
	yy = yy*(-1.0);
      
      /* printf("yy = %lg \n",yy); */
      x[0] = 0.1488743389;
      x[1] = 0.4333953941; 
      x[2] = 0.6794095682;
      x[3] = 0.8650633666;
      x[4] = 0.9739065285;
      w[0]  = 0.2955242247;
      w[1]  = 0.2692667193;
      w[2]  = 0.2190863625;
      w[3]  = 0.1494513491;
      w[4]  = 0.0666713443;
      xm = 0.5*yy;
      xr = 0.5*yy;
    cdf = 0.0;
    for( i=0 ; i<5 ; i++)
      {
      dx=xr*x[i];
      cdf = cdf + w[i]*(1/sqrt(2*PI))*(exp(-0.5*(xm+dx)*(xm+dx))+ 
            exp(-0.5*(xm-dx)*(xm-dx)));
	}
    cdf = xr*cdf;
    if(X >= 0.0) 
      cdf = 0.5 + cdf;
    if(X <  0.0) 
      cdf = 0.5 - cdf;
    }

return(cdf);
}

  
double normal_invcdf(double p)
{

/* ##################################################################
! #                                                                #
! #  Computes the inverse of the cdf of a standard normal at the   #
! #  point p (p in [0,1])                                          #
! #                                                                #
! ##################################################################*/
  
  double invnor, sign, Y, z, out1, out2;
  double xden[5], xnum[5];
  
  xnum[0] = -0.322232431088;
  xnum[1] = -1.000000000000;
  xnum[2] = -0.342242088547;
  xnum[3] = -0.020423121025;
  xnum[4] = -0.000045364221;
  xden[0] =  0.099348462606;
  xden[1] =  0.588581570495;
  xden[2] =  0.531103462366;
  xden[3] =  0.103537752850;
  xden[4] =  0.003856070063;
  
  if(p >= 1.0)
    return(5.0);
  
  else if(p <= 2.866516e-07)
    return(-5.0);
  
  else if(p <= 0.5)
    {
      sign = -1.0;
      z = p;
      Y = sqrt(-2.0*log(z));
      out1 = devlpl(xnum,Y);
      out2 = devlpl(xden,Y);
      invnor = Y + out1/out2;
      invnor = sign*invnor;
      return(invnor);
    }
  else 
    {
      sign = 1.0;
      z = 1.0 - p; 
      Y = sqrt(-2.0*log(z));
      out1 = devlpl(xnum,Y);
      out2 = devlpl(xden,Y);
      invnor = Y + out1/out2;
      invnor = sign*invnor;
      return(invnor);
    }
  
}



double devlpl(double *AA , double XX)
{
  
  double polyn;
  int i;
  
  polyn = AA[4];
  
  for(i = 1 ; i <= 4 ; i++)
    polyn = AA[(4-i)] + polyn*XX;
  
  return(polyn);
}
