#include "setup.h"
#include "random.h"
#include "rmvnormd.h"

void rmvnormf(mean, L, p, result)
/**************************************************************
random realization from a p-variate N(mean,Sigma) distribution
with Sigma = LL'.  Choleski decomp of Sigma is required.
  mean[p] mean of the nomral dist
  L[p][p] Choleski decomp of the covariance matrix
  result[p] The p-variate realization.
**************************************************************/

double *mean, **L, *result;
int p;
{
     int i, j, k;
     double *z, rnor();
     z = dvector(0,p-1);

     /*printf("\nGot into rmvnormf function!");*/
     
     for(k=0;k<p;k++) z[k] = rnor(0.0,1.0);

     /*printf("\nFinished generation from rnor in rmvnormf:\n");
     for (i=0; i<p; i++)
       printf("%lf\t", z[i]);
     printf("\n");*/

     /*printf("Here is L matrix:\n");
     for (i=0; i<p; i++)
       {
	 for (j=0; j<p; j++)
	   {
	     printf("%lf\t", L[i][j]);
	   }
	 printf("\n");
       }*/

                                                                               
     /* set result = Lz + mean*/

     for(i=0;i<p;i++){
       result[i] = 0.0;
       for(j=0;j<=i;j++){
         result[i] += L[i][j]*z[j];
       }
     }

     /*printf("\nGot through with double loop in rmvnormf.");*/

     for(i=0;i<p;i++) result[i] += mean[i];
     
     /*printf("result = ");
     dprintvec(result,p);*/
     

     free_dvector(z,0,p-1);
     return;
}






























