/* #define PI 3.141592653589793 */

extern int nregr;

#define dpotrf dpotrf_
/* Compute the Cholesky factorization of a real symmetric positive 
   definite matrix A */

#define dpotri dpotri_
/* Compute the inverse of a matrix given its choleski factorization */

#define dtrsv  dtrsv_
/* Solver of a system of linear equations with a triangular matrix A: 
    Ax = b, where x and b are vectors */

#define dgemt  dgemt
/* Matrix-matrix copy */

#define dposv  dposv_
/* Compute the solution to a real system of linear equations 
   A * X = B, where A is symmetric, and X and B are matrices */

#define dgema  dgema
/* Matrix-matrix addition */ 

#define dgemm  dgemm_
/* Matrix-matrix product and addition */ 

#define dcopy  dcopy_
/* Copy of a vector */

#define dgemv  dgemv_
/* Matrix-vector product for a general matrix */

#define dnrsq  dnrsq
/* Sum of the squares of the elements of a vector */

extern void dpotrf(char*, int*, double [], int*, int*);
extern void dpotri(char*, int*, double [], int*, int*);
extern void dtrsv(char*, char*, char*, int*, double [], int*,
		  double [], int*); 
extern void dposv(char *, int *, int *, double [], int *, double [], 
                  int *, int *);
extern void dgemm(char*, char*,  int*, int*, int*, double*,
		  double [], int*, double [], int*, double*, double [], int*);
extern void dcopy(int*, double*, int*, double*, int*);
extern void dgemv(char*, int*, int*, double*, double [],  int*, 
                  double [], int*, double*, double [], int*);

typedef struct {   double phiy; 
		   double sigmay2; 
		   double phix; 
                   double sigmax2; 
		   double tau;
                   double *beta;}  PARAM;


void compAV(double, double, int, int, int, double*);

void compAVAt(double, double, int, int, double*);

void compW( PARAM*, int, int, int, double*);

void design_matrix(double *zmatrix, int *harmonics, int num_harms, int nx);
void trans_x(double *xlevel, int nx);
